######################segmento dati#####################################
.data
.align 0							# necessario per scrivere correttamente l'header su file
header: 
.ascii "RIFF"						# RIFF
lungfile: .word 0					# file length - 8
.ascii "WAVE"						# WAVE
.ascii "fmt "						# fmt(spazio)
.word 16							# format data length
.byte 1,0							# PCM
.byte 1,0							# channels number
.word 44100							# sample rate [44100]
.word 88200							# samplerate*bitspersample*channels/8
.byte 2,0							# bitspersample*channels/8
.byte 16,0							# bits per sample
.ascii "data"						# data
lungdati: .word 0					# data section size

.align 2
buffer: .space 8							# buffer per input string
note: .ascii "ABCDEFGP"						# per riconoscimento input, confronto con questi caratteri
diesis: .word 0x00000023 					# per riconoscimento input, nota diesis (codice esadecimale per #)
x: .word 0x00000078							# per riconoscimento input, fine input (codice esadecimale per 'x')
codificate: .space 200						# array codificate, conterrà ogni nota inserita codificata
buffer_sinusoide: .word 0					# buffer per i dati della sinusoide

pi: .double 3.141592653589793				# pi greco
sen: .space 8								# spazio per valore del seno, double (vedere procedura sin)
array_lunghezze: .space 100					# array per lunghezze delle note (vedere procedura calcola dati)
filename: .asciiz "output.wav"				# nome file di output
fine_stringa: .word 0x0000000a				# carattere di fine stringa, per controllo validità input

# stringhe da stampare
stringa_errore_input: .asciiz "La nota inserita non è valida. Riprovare: \n"
stringa_status_1: .asciiz "Scrittura su file in corso...\n"
stringa_status_2: .asciiz "Completati "
stringa_status_3: .asciiz "/"
stringa_status_4: .asciiz " byte\n"
stringa_status_5: .asciiz "Scrittura completata.\n"
stringa_start_1: .asciiz "\t\tSintetizzatore sine wave\n\t\tdi Federico Bonfiglio\n\n"
stringa_start_2: .asciiz "Dopo aver selezionato il tempo, inserire note e rispettive durate (per esempio 'C4', 'F#2' o 'P3').\nSaranno scritte su file come onde sinusoidali.\n\n"
stringa_start_3: .asciiz "Note ('x' per terminare):\n"
stringa_tempo: .asciiz "Selezionare il tempo, 1 per tempo veloce, 2 per tempo lento:\n"
errore_tempo: .asciiz "Tempo non valido.\n"
#################################fine segmento dati#####################

.text
#################################main###################################
# legge una sequenza di stringhe rappresentanti note e tempi
# terminata con "x" (tramite chiamata a procedura ricorsiva)
# e scrive su file le note corrispondenti

main:
# stampa informazioni iniziali
li $v0, 4							# $v0 = 4 syscall code per print_string
la $a0, stringa_start_1				# $a0 = indirizzo stringa
syscall								# print_string
li $v0, 4							# $v0 = 4 syscall code per print_string
la $a0, stringa_start_2				# $a0 = indirizzo stringa
syscall								# print_string

li $v0, 4							# $v0 = 4 syscall code per print_string
la $a0, stringa_tempo				# $a0 = indirizzo stringa
syscall								# print_string

# leggi input
scegli_tempo:						
li $v0, 5							# $v0 = 5 syscall code per read_int
syscall								# read_int (in $v0)
li $t0, 1							# $t0 = 1
beq $v0, $t0, veloce				# if ($t0==$v0) b veloce
li $t0, 2							# $t0 = 2
beq $v0, $t0, lento					# if ($t2==$v0) b lento

li $v0, 4							# else errore: $v0 = 4 syscall code per print_string
la $a0, errore_tempo				# $a0 = indirizzo stringa
syscall								#print_string
j scegli_tempo						# j scegli_tempo, scegliere di nuovo il tempo

veloce:
li $s7, 11025						# $s7 = 11025, numero di byte per la nota più breve
j continua_input					# continua con l'input
lento:
li $s7, 22050						# $s7 = 22050

continua_input:
li $v0, 4							# $v0 = 4 syscall code per print_string
la $a0, stringa_start_3				# $a0 = indirizzo stringa
syscall								# print_string

la $a1, codificate					# $a1 = indirizzo note codificate
li $a0, 0							# $a0 = 0, significa che è la prima istanza
jal read_input						# chiamata a read_input

#prima move $s0, $v0 ora sembra inutile
#prima la prossima istruzione aveva $s0 ovviamente

# conteggio dati da scrivere, lw in header
move $a0, $v0						# $a0 = indirizzo ultima nota codificata
jal calcola_dati					# chiamata a calcola_dati
la $t0, lungfile					# $t0 = indirizzo per la lunghezza del file (verrà scritto nell'header)
sw $v0, 0($t0)						# store $v0 at $t0, lunghezza del file nell'header
la $t0, lungdati					
sw $v1, 0($t0)						# store lunghezza dati nell'header
move $s2, $v1

# scrittura su file
# apri file																	
li $v0, 13							# $v0 = 13 syscall code per aprire il file
la $a0, filename					# $a0 = indirizzo nome del file
li $a1, 1 							# $a1 = 1 modalità scrittura
li $a2, 0							# mode ignored
syscall								# open_file
move $s6, $v0						# $s6 = file descriptor

# scrittura	header	
li $v0, 15							# $v0 = 15 syscall code per scrittura 
move $a0, $s6						# $a0 = $s6 file descriptor
la $a1, header						# $a1 = indirizzo dati da scrivere (header)
li $a2, 44							# $a2 = 44 lunghezza buffer, corrisponde all'header
syscall								# write_file
# fine scrittura header

# scrittura note
move $a0, $s2						# $a0 = $s2 lunghezza totale dei dati
jal scrivi_note						# chiamata a scrivi_note

# chiusura file
li $v0, 16							# $v0 = 16 syscall code per chiusura file
move $a0, $s6						# $a0 = file descriptor
syscall								# close_file
# fine scrittura

li $v0, 4							# $v0 = 4 syscall code per print_string
la $a0, stringa_status_5			# $a0 = indirizzo stringa
syscall								# print_string

li $v0, 10							# $v0 = 10 syscall code per exit
syscall								#exit

#################################fine main##############################

################################read_input##############################
# in input a0 = nota codificata
# a1 = indirizzo dove salvare la nota
# ogni stack frame contiene nota codificata e indirizzo a cui deve essere salvata
# il caso base restituisce l'indirizzo dell'ultima nota = $v0

read_input:
addi $sp, $sp, -16					# $sp -= 16 alloco spazio per stack frame
sw $ra, 0($sp)						# salvo $ra
sw $a0, 4($sp)						# salvo $a0 (nota codificata dopo la prima istanza)
sw $a1, 8($sp)						# salvo $a1 (indirizzo a cui andrà salvata la nota)
sw $fp, 12($sp)						# salvo $fp
addi $fp, $sp, 12					# set $fp

leggi_stringa:
li $v0, 8							# $v0 = 8 syscall code per read_string
la $a0, buffer						# $a0 = buffer address 
li $a1, 5							# $a1 = lunghezza dati da leggere
syscall								# read_string

#if stringa != x step ricorsivo
lb $t0, 0($a0)						# $t0 = primo byte stringa
la $t1, x							# $t1 = indirizzo 'x' (per confronto successivo)
lb $t2, 0($t1)						# $t2 = 'x'
bne $t0, $t2, step_ricorsivo		# if ($t0==$t2) b step_ricorsivo

#else caso base
lw $t0, 8($sp)						# $t0 = indirizzo ultima nota 
lw $t1, 4($sp)						# $t1 = ultima nota codificata
sw $t1, 0($t0)						# store $t1 at $t0
move $v0, $t0						# $v0 = $t0
addi $sp, $sp, 16					# dealloco stack frame
jr $ra								# ritorna il controllo al chiamante

step_ricorsivo:
la $a0, note						# $a0 = indirizzo caratteri note
la $a1, buffer						# $a1 = indirizzo buffer (stringa inserita != 'x')
addi $sp, $sp, -4					# $sp -= 4 alloco spazio per $ra
sw $ra, 0($sp)						# save $ra
jal codifica						# chiamata a codifica
lw $ra, 0($sp)						# restore $ra
addi $sp, $sp, 4					# dealloco stack frame

beq $v1, $zero, input_corretto		# if ($v1==0) b input_corretto (vedi codifica)

# messaggio d'errore input
li $v0, 4							# else: $v0 = 4 syscall code per print_string 
la $a0, stringa_errore_input		# $a0 = indirizzo stringa
syscall								# print_string
j leggi_stringa						# j leggi_stringa leggi una nuova stringa

input_corretto:
move $a0, $v0						# $a0 = $v0, passa la nota codificata alla nuova istanza
lw $t0, 8($sp)						# carica dallo stack l'indirizzo
addi $t0, $t0, 4					# incrementa l'indirizzo base delle note codificate
move $a1, $t0						# passalo come parametro alla nuova istanza
jal read_input						# chiamata ricorsiva

#leggi dallo stack la nota
lw $t0, 4($sp)						# $t0 = nota codificata
lw $t1, 8($sp)						# $t1 = indirizzo dove salvare la nota
sw $t0, 0($t1)						# store $t0 at $t1
lw $ra, 0($sp)						# ripristino $ra
lw $fp, 12($sp)						# ripristino $fp
addi $sp, $sp, 16					# dealloco stack frame
jr $ra								# ritorno il controllo al chiamante
###############################fine input###############################

###############################codifica#################################
# a0 = indirizzo note
# a1 = indirizzo input
#
# codifica di una stringa del tipo "LETTERENOTA"+"numerotempo" 
# in una parola con i 16 msb rappresentanti il numero della nota,
# i 16 lsb il numero di unità temporali.
#
codifica:
addi $sp, $sp, -12					# $sp -= 12
sw $s0, 0($sp)						# salvo $s0
sw $s1, 4($sp)						# salvo $s1
sw $fp, 8($sp)						# salvo $fp
addi $fp, $sp, 8					# set $fp

move $s0, $a0						# $s0 = $a0
move $s1, $a1						# $s1 = $a1
start:
lb $t0, 1($s1)						# $t0 = secondo byte input
la $t1, diesis						# $t1 = indirizzo diesis
lb $t1, 0($t1)						# $t1 = diesis char
beq $t0, $t1, nota_diesis			# if ($t0 == $t1) b nota_diesis

#else: non diesis
lb $t2, 1($s1)						# $t2 = secondo byte input (tempo)	
subu $t2, $t2, 48					# $t2 -= 48 conversione da char a int

li $t3, 10							# $t3 = 10
bge $t2, $t3, errore_input			# if ($t2 >= 10) b errore_input (significa che non è stato inserito un numero) 
ble $t2, $zero, errore_input		# if ($t2 <= 0) b errore_input
la $t3, fine_stringa				# $t3 = indirizzo carattere di terminazione stringa
lb $t3, 0($t3)						# $t3 = carattere di terminazione stringa
lb $t5, 2($s1)						# $t5 = terzo byte input (non diesis)
bne $t5, $t3, errore_input			# if ($t5 != $t3) b errore_input (la stringa in input contiene troppi caratteri)

lb $t1, 0($s1)						# $t1 = primo byte input
lb $t0, 0($s0)						# $t0 = char A	switch ($t1)
beq $t0, $t1, A						# case: 'A' b at A
lb $t0, 1($s0)						# $t0 = char B
beq $t0, $t1, B						# case 'B': b at B
lb $t0, 2($s0)						# $t0 = char C
beq $t0, $t1, C						# case 'C': b at C
lb $t0, 3($s0)						# $t0 = char D
beq $t0, $t1, D						# case 'D': b at D
lb $t0, 4($s0)						# $t0 = char E
beq $t0, $t1, E						# case 'E': b at E
lb $t0, 5($s0)						# $t0 = char F
beq $t0, $t1, F						# case 'F': b at F
lb $t0, 6($s0)						# $t0 = char G
beq $t0, $t1, G						# case 'G': b at G
lb $t0, 7($s0)						# $t0 = char P
beq $t0, $t1, P						# case 'P': b at P
j errore_input						# default: j errore_input (tutti gli altri caratteri non sono ammessi)

nota_diesis:
lb $t2, 2($s1)						# $t2 = terzo byte input (tempo se diesis)
subu $t2, $t2, 48					# conversione char -> int

li $t3, 10							# come per il caso non diesis
bge $t2, $t3, errore_input			
ble $t2, $zero, errore_input
la $t3, fine_stringa
lb $t3, 0($t3)
lb $t5, 3($s1)
bne $t5, $t3, errore_input

lb $t1, 0($s1)						# $t1 = primo byte input
lb $t0, 0($s0)						# $t0 = char A	switch ($t1)
beq $t0, $t1, Ad					# switch come per il caso non diesis
lb $t0, 2($s0)
beq $t0, $t1, Cd
lb $t0, 3($s0)
beq $t0, $t1, Dd
lb $t0, 5($s0)
beq $t0, $t1, Fd
lb $t0, 6($s0)
beq $t0, $t1, Gd
j errore_input						# default: j errore_input

# per ogni nota $t0 = frequenza
C:					
li $t0, 261							# $t0 = frequenza C
j end_codifica						# j end_codifica
Cd:
li $t0, 277
j end_codifica
D:
li $t0, 293
j end_codifica
Dd:
li $t0, 311
j end_codifica
E:
li $t0, 329
j end_codifica
F:
li $t0, 349
j end_codifica
Fd:
li $t0, 369
j end_codifica
G:
li $t0, 391
j end_codifica
Gd:
li $t0, 415
j end_codifica
A:
li $t0, 440
j end_codifica
Ad:
li $t0, 466
j end_codifica
B:
li $t0, 493
j end_codifica
P:									# in caso di pausa la frequenza è zero così da annullare i dati
li $t0, 0								

end_codifica:
li $t3, 16							# $t3 = shamt
sll $t0, $t0, $t3					# shift left $t0 by 16
add $v0, $t0, $t2					# $v0 = $t0 + $t2 (frequenza nei 16 msb, tempo nei 16 lsb)
li $v1, 0							# flag per nessun errore di input

j no_error
errore_input:
li $v1, 1							# flag per errore di input
no_error:
lw $s1, 4($sp)						# ripristino $s1
lw $s0, 0($sp)						# ripristino $s0 
lw $fp, 8($sp)						# ripristino $fp
addi $sp, $sp, 12					# dealloco stack frame
jr $ra								# ritorno del controllo al chiamante
###############################fine codifica############################

##################################scrivi_note###########################
#input: $a0 = dati totali

scrivi_note:
addi $sp, $sp, -12					# $sp -= 12
sw $ra, 0($sp)						# salvo $ra
sw $s0, 4($sp)						# salvo $s0
sw $fp, 8($sp)						# salvo $fp
addi $fp, $sp, 8					# set $fp

move $s0, $a0						# $s0 = $a0 (lunghezza totale dati)

li $v0, 4							# $v0 = 4 syscall code per print_string
la $a0, stringa_status_1			# $a0 = indirizzo stringa
syscall								# print_string

li $t0, 2							# $t0 = 2 (per divisione)
div $s0, $s0, $t0					# $s0 /= $t0(2) serve il numero dei dati non in byte (due byte per ogni dato)
la $t2, codificate					# $t2 = indirizzo note codificate
la $t3, array_lunghezze				# $t3 = indirizzo lunghezze note
li $t1, 0							# $t1 = 0 inizializzazione contatore b = 0
loop_scrittura_1:

li $t4, 0							# $t4 = 0 inizializzazione secondo contatore c = 0
	loop_scrittura_2:
	move $a1, $t1					# $t1 = a1
	lw $a0, 0($t2)					# carica nota da codificate in $a0		
	beq $a0, $zero, prima			# if ($a0 == $zero) b prima (significa che è la nota "vuota" della prima istanza)
	li $t6, 16						# $t6 = 16 shamt 
	srl $a0, $a0, $t6				# shift right di $a0 di 16 bit (interessa solo la frequenza della nota, cioè i 16 msb)
	lw $t5, 0($t3)					# carica in $t5 lunghezza dei dati per questa nota
	li $t7, 2						# $t7 = 2 (come prima, non servono in byte)
	div $t5, $t5, $t7				# $t5 /= $t7(2)
	li $a2, 8000					# ampiezza sinusoide	

	addi $sp, $sp, -16				# salvataggio temporanei
	sw $t1, 4($sp)					# salvo $t1
	sw $t2, 8($sp)					# salvo $t2
	sw $t4, 12($sp)					# salvo $t4
	jal sinusoide					# chiamata a sinusoide
	lw $t1, 4($sp)					# ripristino $t1
	lw $t2, 8($sp)					# ripristino $t2
	lw $t4, 12($sp)					# ripristino $t4
	addi $sp, $sp, 16				# dealloco stack

	li $v0, 15						# $v0 = 15 syscall code per scrivere su file
	move $a0, $s6					# $a0 = $s6 file descriptor
	la $a1, buffer_sinusoide		# $a1 = indirizzo del dato corrente della sinusoide 	
	li $a2, 2						# lunghezza dato da scrivere
	syscall							# write_file (scrive il dato della sinusoide)

	move $a0, $s0					# $a0 = $s0 (lunghezza totale dei dati)
	move $a1, $t1					# $a1 = $t1 (posizione dato corrente)
	jal stampa_status				# chiamata a stampa_status

	addi $t1, $t1, 1				# $t1 += 1 incrementa contatore b
	addi $t4, $t4, 1				# $t4 += 1 incrementa contatore c
	bne $t5, $t4, loop_scrittura_2	# while ($t5 != $t4) b loop_scrittura_2

prima:
addi $t2, $t2, 4					# $t2 += 4 incrementa puntatore a codificate di uno
addi $t3, $t3, 4					# $t3 += 4 incrementa puntatore a array_lunghezze di uno

blt $t1, $s0, loop_scrittura_1		# while ($t1 < $s0) b loop_scrittura_1 (serve il minore per il tempo veloce)

lw $ra, 0($sp)						# ripristino $ra
lw $s0, 4($sp)						# ripristino $s0
lw $fp, 8($sp)						# ripristino $fp
addi $sp, $sp, 12					# dealloco stack

jr $ra								# ritorno il controllo al chiamante
################################fine scrivi_note########################

########################stampa status###################################
# procedura chiamata durante la scrittura, informa l'utente
# sullo stato dell'operazione

stampa_status:
li $t9, 2
mul $t0, $a0, $t9					# $t0 = totale dati in byte
mul $t9, $a1, $t9					# $t9 = parziale dati in byte

li $t8, 2205						# $t8 = 2205 per stampare solo ogni 2205 byte
div $t9, $t8						# $t9/$t8
mfhi $t8							# $t8 = $t9%$t8
bne $t8, $zero, non_stampare		# if ($t9%$t8!=0) b non_stampare	

li $v0, 4							# else stampa: $v0 = 4 syscall code per print_string
la $a0, stringa_status_2			# $a0 = indirizzo stringa
syscall								# print_string

move $a0, $t9						# $a0 = $t9 
li $v0, 1							# $v0 = 1 syscall code per print_int
syscall								# print_int (parziale scritto dei byte)	

li $v0, 4							# $v0 = 4 syscall code per print_string
la $a0, stringa_status_3			# $a0 = indirizzo stringa "/" 
syscall								# print_string

li $v0, 1							# $v0 = 1 syscall code per print_int
move $a0, $t0						# $a0 = $t0 (totale byte)
syscall								# print_int

li $v0, 4							# $v0 = 4 syscall code per print_string
la $a0, stringa_status_4			# $a0 = indirizzo stringa
syscall								# print_string

non_stampare:
jr $ra								# ritorna il controllo al chiamante
#################################fine stampa status#####################

#############################sinusoide##################################
#funzione sinusoide
#$a0 = frequenza
#$a1 = x
#$a2 = ampiezza (8000)
#dato sinusoide a buffer_sinusoide (output)

sinusoide:
addi $sp, $sp, -16					# $sp -= 12 alloco spazio per stack frame		
sw $s2, 8($sp)						# salvo $s2
sw $s1, 4($sp)						# salvo $s1
sw $ra, 0($sp)						# salvo $ra
sw $fp, 12($sp)						# salvo $fp
addi $fp, $sp, 12					# set $fp

move $s1, $a1						# $s1 = $a1 (x)
move $s5, $a0						# $s5 = $a0 (frequenza)
beq $s5, $zero, freq_zero			# if ($s5 == $zero) b freq_zero (non calcola la sinusoide, è una pausa)
move $s2, $a2						# $s2 = $a2 (ampiezza)

mtc1.d $s1, $f0						# $f0 = $S1 ((double)x)
cvt.d.w $f0, $f0					# conversione int -> double

l.d $f4, pi							# $f4 = pi greco

mtc1.d $s5, $f2						# $f2 = $s5 ((double) frequenza)
cvt.d.w $f2, $f2					# conversione int -> double

li $t0, 2							# $t0 = 2
mtc1.d $t0, $f6						# $f6 = 2
cvt.d.w $f6, $f6					# conversione int -> double
mul.d $f6, $f6, $f4					# $f6 = 2*pi
mul.d $f6, $f6, $f2					# $f6 = 2*pi*freq
mul.d $f0, $f6, $f0					# $f0 = 2*pi*freq*x
li $t0, 44100						# $t0 = 44100
mtc1.d $t0, $f2						# $f2 = $t0 ((double)frame rate)
cvt.d.w $f2, $f2					# conversione int -> double
div.d $f0, $f0, $f2					# $f0 = $f0 / 44100 ((2*pi*freq*x)/frame rate)

jal sin								# chiamata a procedura sin, calcolerà sin((2*pi*freq*x)/frame rate)

l.d $f0, sen						# $f0 = sin(x) (quello appena calcolato)
mtc1.d $s2, $f8						# $f8 = $s2 ampiezza
cvt.d.w $f8, $f8					# conversione int -> double
mul.d $f0, $f0, $f8					# $f0 = $f0*$f8 sin(x)*(ampiezza)
cvt.w.d $f0, $f0					# conversione double -> int
mfc1 $t2, $f0						# $t2 = $f0

j continua							# se la frequenza non era zero
freq_zero:							
move $t2, $s5						# $t2 = $s5 se frequenza zero, il dato è pari alla frequenza (pausa)
continua:	
la $t0, buffer_sinusoide			# $t0 = indirizzo buffer_sinusoide
sw $t2, 0($t0)						# store sin(x)*ampiezza at buffer_sinusoide

lw $ra, 0($sp)						# ripristino $ra
lw $s1, 4($sp)						# ripristino $s1
lw $s2, 8($sp)						# ripristino $s2
lw $fp, 12($sp)						# ripristino $fp
addi $sp, $sp, 16					# $sp += 16 dealloco stack
jr $ra								# ritorno il controllo al chiamante
############################fine sinusoide##############################

########################sen(x)##########################################
# calcola il seno di un numero dato
# tramite sviluppo in serie di Taylor fino a precisione O(x^21)
# precisione minima necessaria per ottenere un'onda buona alla fine

sin:
addi $sp, $sp, -16					# $sp -= 16, alloco spazio per stack frame
sw $s0, 4($sp)						# salvo $s0
sw $ra, 0($sp)						# salvo $ra
sw $s2, 8($sp)						# salvo $s2
sw $fp, 12($sp)						# salvo $fp
addi $fp, $sp, 12					# set $fp

# f0 = x	fa da a0, l'input è double
# output at sen (segmento dati)

mtc1 $zero, $f12					# $f12 = $zero
cvt.d.w $f12, $f12					# conversione int -> double	somma parziale iniziale = 0

# la x viene ricondotta ad un intervallo tra zero e 2pi
l.d $f2, pi							# $f2 = pi
li $t0, 2						    # $t0 = 2
mtc1.d $t0, $f4					    # $f4 = $t0
cvt.d.w $f4, $f4					# conversione int -> double
mul.d $f2, $f2, $f4					# $f2 *= $f4 (2*pi)
									# calcolo x%(2*pi)
mov.d $f4, $f0						# $f4 = $f0 = x
div.d $f6, $f4, $f2				    # $f6 = $f4/$f2 x/(2*pi)
cvt.w.d $f6, $f6					# conversione double -> int, quoziente come intero
cvt.d.w $f6, $f6					# conversione int -> double del quoziente intero
mul.d $f6, $f2, $f6					# $f6 *= $f2
sub.d $f4, $f4, $f6					# $f4 = mod, nuova x

li $s2, 0						#$s2 = contatore(n)
loop2:

# calcolo (-1)^n
li $t1, 2							# se n è pari, -1^n = 1, altrimenti -1
div $s2, $t1						# $s2 /$t1 (controllo se è pari o dispari)
mfhi $t1							# $t1 = $s2%$t1
beq $t1, $zero, npari				# if ($t1 == 0) b npari
li $s0, -1							# else: n è dispari, $s0 = -1
j ndispari							# j ndispari
npari:							
li $s0, 1							# $s0 = 1
ndispari:						
# $s0 contiene (-1)^n

li $t2, 2							# $t2 = 2
mul $t2, $t2, $s2					# $t2 *= $t2 (n*2)
addi $s4, $t2, 1					# $s4 = $t2 + 1 (2n+1)

move $a0, $s4						# $a0 = $s4
jal fattoriale						# chiamata a fattoriale, poi fattoriale di $s4 in $f0 = (2n+1)!

mtc1.d $s0, $f2						# $f2 = $s0 
cvt.d.w $f2, $f2					# conversione int -> double $f2 = (-1)^n

div.d $f0, $f2, $f0					# $f0 = $f2/$f0 (-1)^n/(2n+1)!

mov.d $f6, $f4						# $f6 = x (= $f4)
mov.d $f8, $f6						# $f8 = $f6		(x in entrambi i registri)
li $t4, 1							# $t4 = 1 		(per comparazione)
beq $s4, $t4, nopot					# se 2n+1 == 1 non elevare a potenza (x^1==x)
beq $s4, $zero, nopotuno			# se 2n+1 == 0 x diventa uno 
li $t0, 1							# else: contatore, $t0 = 1
potenza:
mul.d $f8, $f8, $f6					# $f8 = x^(2n+1)
addi $s4, $s4, -1					# $s4--
bne $s4, $t0, potenza				# while($s4!=$t0) b potenza
nopotuno:
li $t0, 1							# $t0 = 1
mtc1.d $t0, $f6						# $f6 = $t0
cvt.d.w $f6, $f6					# conversione int-> double
nopot:

mul.d $f0, $f0, $f8					# $f0 = ((-1)^n/(2n+1)!)*x^(2n+1)
			
add.d $f12, $f12, $f0				# $f12 += $f0 incremento somma parziale
li $t0, 10							# $t0 = 10 precisione sviluppo in serie di Taylor					
beq $t0, $s2, fineloop				# while ($t0 != $s2) loop (se diversi, b at fineloop) 
addi $s2, $s2 1						# $s2+=1
j loop2								# j loop2

fineloop:
s.d $f12, sen						# store $f12 (somma finale) at sen
lw $ra, 0($sp)						# ripristino $ra
lw $s0, 4($sp)						# ripristino $s0
lw $s2, 8($sp)						# ripristino $s2
lw $fp, 12($sp)						# ripristino $fp
addi $sp, $sp, 16					# $sp +=12 dealloco stack frame
jr $ra								# ritorno il controllo al chiamante
################################fine sin################################

###############################fattoriale###############################	
fattoriale:
# $a0 = n		
# $f0 = n fattoriale

addi $sp, $sp, -12					# alloco spazio
sw $a0, 0($sp)						# nello stack frame: n
sw $ra, 4($sp) 						# salvo $ra
sw $fp, 8($sp)						# salvo $fp
addi $fp, $sp, 8					# set $fp
addi $a0, $a0, -1					# $a0 -= 1

bne $a0, $zero, step_ricorsivo_fattoriale	# finché $a0 non è zero, step_ricorsivo
li $v0, 1							# else: caso base, $v0 = 1
mtc1.d $v0, $f0						# $f0 = $v0
cvt.d.w $f0, $f0					# conversione int -> double
addi $sp, $sp, 12					# dealloco stack frame
jr $ra								# ritorno il controllo al chiamante

step_ricorsivo_fattoriale: 			# ricorsivo
jal fattoriale

lw $t0, 0($sp)						# $t0 = $a0 precedente
mtc1.d $t0, $f2						# $f2 = $a0pre
cvt.d.w $f2, $f2					# conversione int -> double

mul.d $f0, $f0, $f2					# $f0 fa da $v0
lw $ra, 4($sp)						# restore $ra
lw $fp, 8($sp)						# restore $fp
addi $sp, $sp, 12					# dealloco stack frame
jr $ra								# ritorno il controllo al chiamante
##########################fine fattoriale###############################

#######################calcola dati#####################################
# calcola, in byte, la lunghezza del file.
# $a0 = ultima nota inserita
#
# $v0 = lungfile, lunghezza file - 8
# $v1 = lungdati, lungfile + 8 - 44 (+36)
# array_lunghezze: array di dati per ogni nota nell'array codificate

calcola_dati:
la $t4, array_lunghezze				# $t4 = indirizzo array_lunghezze

li $t3, 0							# $t3 = 0
la $t0, codificate					# $t0 = indirizzo codificate
move $t1, $a0						# $t1 = address ultima nota inserita
loop_header:
lh $t2, 0($t0)						# carica il tempo della nota in $t2
move $t5, $s7						# $t5 = unità base lunghezza note in $s7, a seconda del tempo selezionato
mul $t2, $t2, $t5					# $t2 *= $t5

sw $t2, 0($t4)						# store $t2 nell'array delle lunghezze
add $t3, $t3, $t2					# $t3 += $t2

addi $t4, $t4, 4					# incrementa array_lunghezze
addi $t0, $t0, 4					# $t0 += 4
ble $t0, $t1 loop_header			# if ($t0 <= $t1) b loop_header

move $v1, $t3						# lunghezza dati
		
li $t1, 8							# $t1 = 8
sub $v0, $t3, $t1					# $v0 = $t3 - $t1	
addi $v0, $v0, 44					# $v0 = lunghezza dati+header -8
jr $ra								# ritorno il controllo al chiamante


